=head1 NAME

perlbook - Books about and related to Perl

=head1 DESCRIPTION

There are many books on Perl and Perl-related. A few of these are
good, some are OK, but many aren't worth your money. There is a list
of these books, some with extensive reviews, at
L<https://www.perl.org/books/library.html> . We list some of the books here, and while
listing a book implies our
endorsement, don't think that not including a book means anything.

Most of these books are available online through O'Reilly Online Learning
( L<https://www.oreilly.com> ).

=head2 The most popular books

The major reference book on Perl, written by the creator of Perl, is
I<Programming Perl>:

=over 4

=item I<Programming Perl> (the "Camel Book"):

 by Tom Christiansen, brian d foy, Larry Wall with Jon Orwant
 ISBN 978-0-596-00492-7 [4th edition February 2012]
 ISBN 978-1-4493-9890-3 [ebook]
 https://www.oreilly.com/library/view/-/9781449321451/

=back

The Ram is a cookbook with hundreds of examples of using Perl to
accomplish specific tasks:

=over 4

=item I<The Perl Cookbook> (the "Ram Book"):

 by Tom Christiansen and Nathan Torkington,
 with Foreword by Larry Wall
 ISBN 978-0-596-00313-5 [2nd Edition August 2003]
 ISBN 978-0-596-15888-0 [ebook]
 https://www.oreilly.com/library/view/-/0596003137/

=back

If you want to learn the basics of Perl, you might start with the
Llama book, which assumes that you already know a little about
programming:

=over 4

=item I<Learning Perl>  (the "Llama Book")

 by Randal L. Schwartz, Tom Phoenix, and brian d foy
 ISBN 978-1-4920-9495-1 [8th edition August 2021]
 ISBN 978-1-4920-9492-0 [ebook]
 https://www.learning-perl.com/

=back

The tutorial started in the Llama continues in the Alpaca, which
introduces the intermediate features of references, data structures,
object-oriented programming, and modules:

=over 4

=item I<Intermediate Perl> (the "Alpaca Book")

 by Randal L. Schwartz and brian d foy, with Tom Phoenix
         foreword by Damian Conway
 ISBN 978-1-4493-9309-0 [2nd edition August 2012]
 ISBN 978-1-4493-0459-1 [ebook]
 https://www.intermediateperl.com/

=back

=head2 References

You might want to keep these desktop references close by your keyboard:

=over 4

=item I<Perl 5 Pocket Reference>

 by Johan Vromans
 ISBN 978-1-4493-0370-9 [5th edition July 2011]
 ISBN 978-1-4493-0813-1 [ebook]
 https://www.oreilly.com/library/view/-/9781449311186/

=item I<Perl Debugger Pocket Reference>

 by Richard Foley
 ISBN 978-0-596-00503-0 [1st edition January 2004]
 ISBN 978-0-596-55625-9 [ebook]
 https://www.oreilly.com/library/view/-/9781449311186/

=item I<Regular Expression Pocket Reference>

 by Tony Stubblebine
 ISBN 978-0-596-51427-3 [2nd edition July 2007]
 ISBN 978-0-596-55782-9 [ebook]
 https://www.oreilly.com/library/view/-/9780596514273/

=back

=head2 Tutorials

=over 4

=item I<Beginning Perl>

(There are 2 books with this title)

 by Curtis 'Ovid' Poe
 ISBN 978-1-118-01384-7
 https://www.wiley.com/en-ie/Beginning+Perl-p-9781118235638

 by James Lee
 ISBN 1-59059-391-X [3rd edition April 2010 & ebook]
 https://www.apress.com/9781430227939

=item I<Learning Perl> (the "Llama Book")

 by Randal L. Schwartz, Tom Phoenix, and brian d foy
 ISBN 978-1-4493-0358-7 [6th edition June 2011]
 ISBN 978-1-4493-0458-4 [ebook]
 https://www.learning-perl.com/

=item I<Intermediate Perl> (the "Alpaca Book")

 by Randal L. Schwartz and brian d foy, with Tom Phoenix
         foreword by Damian Conway
 ISBN 978-1-4493-9309-0 [2nd edition August 2012]
 ISBN 978-1-4493-0459-1 [ebook]
 https://www.intermediateperl.com/

=item I<Mastering Perl>

    by brian d foy
 ISBN 9978-1-4493-9311-3 [2nd edition January 2014]
 ISBN 978-1-4493-6487-8 [ebook]
 https://www.masteringperl.org/

=item I<Effective Perl Programming>

 by Joseph N. Hall, Joshua A. McAdams, brian d foy
 ISBN 0-321-49694-9 [2nd edition 2010]
 https://www.effectiveperlprogramming.com/

=back

=head2 Task-Oriented

=over 4

=item I<Writing Perl Modules for CPAN>

 by Sam Tregar
 ISBN 1-59059-018-X [1st edition August 2002 & ebook]
 https://www.apress.com/9781590590188>

=item I<The Perl Cookbook>

 by Tom Christiansen and Nathan Torkington,
     with Foreword by Larry Wall
 ISBN 978-0-596-00313-5 [2nd Edition August 2003]
 ISBN 978-0-596-15888-0 [ebook]
 https://www.oreilly.com/library/view/-/0596003137/

=item I<Automating System Administration with Perl>

 by David N. Blank-Edelman
 ISBN 978-0-596-00639-6 [2nd edition May 2009]
 ISBN 978-0-596-80251-6 [ebook]
 https://www.oreilly.com/library/view/-/9780596801892/

=item I<Real World SQL Server Administration with Perl>

 by Linchi Shea
 ISBN 1-59059-097-X [1st edition July 2003 & ebook]
 https://www.apress.com/9781590590973

=back

=head2 Special Topics

=over 4

=item I<Regular Expressions Cookbook>

 by Jan Goyvaerts and Steven Levithan
 ISBN 978-1-4493-1943-4 [2nd edition August 2012]
 ISBN 978-1-4493-2747-7 [ebook]
 https://shop.oreilly.com/product/0636920023630.do

=item I<Programming the Perl DBI>

 by Tim Bunce and Alligator Descartes
 ISBN 978-1-56592-699-8 [February 2000]
 ISBN 978-1-4493-8670-2 [ebook]
 https://www.oreilly.com/library/view/-/1565926994/

=item I<Perl Best Practices>

 by Damian Conway
 ISBN 978-0-596-00173-5 [1st edition July 2005]
 ISBN 978-0-596-15900-9 [ebook]
 https://www.oreilly.com/library/view/-/0596001738/

=item I<Higher-Order Perl>

 by Mark-Jason Dominus
 ISBN 1-55860-701-3 [1st edition March 2005]
 free ebook https://hop.perl.plover.com/book/
 https://hop.perl.plover.com/

=item I<Mastering Regular Expressions>

 by Jeffrey E. F. Friedl
 ISBN 978-0-596-52812-6 [3rd edition August 2006]
 ISBN 978-0-596-55899-4 [ebook]
 https://learning.oreilly.com/library/view/-/0596528124/

=item I<Network Programming with Perl>

 by Lincoln Stein
 ISBN 0-201-61571-1 [1st edition 2001]
 https://www.oreilly.com/library/view/-/0201615711/

=item I<Perl Template Toolkit>

 by Darren Chamberlain, Dave Cross, and Andy Wardley
 ISBN 978-0-596-00476-7 [December 2003]
 ISBN 978-1-4493-8647-4 [ebook]
 https://www.oreilly.com/library/view/-/0596004761/

=item I<Object Oriented Perl>

 by Damian Conway
     with foreword by Randal L. Schwartz
 ISBN 1-884777-79-1 [1st edition August 1999 & ebook]
 https://www.manning.com/conway/

=item I<Data Munging with Perl>

 by Dave Cross
 ISBN 1-930110-00-6 [1st edition 2001 & ebook]
 https://www.manning.com/cross>

=item I<Mastering Perl/Tk>

 by Steve Lidie and Nancy Walsh
 ISBN 978-1-56592-716-2 [1st edition January 2002]
 ISBN 978-0-596-10344-6 [ebook]
 https://www.oreilly.com/library/view/-/1565927168/

=item I<Extending and Embedding Perl>

 by Tim Jenness and Simon Cozens
 ISBN 1-930110-82-0 [1st edition August 2002 & ebook]
 https://www.manning.com/jenness

=item I<Pro Perl Debugging>

 by Richard Foley with Andy Lester
 ISBN 1-59059-454-1 [1st edition July 2005 & ebook]
 https://www.apress.com/9781590594544

=back

=head2 Free (as in beer) books

Some of these books are available as free downloads.

I<Higher-Order Perl>: L<https://hop.perl.plover.com/>

I<Modern Perl>: L<https://onyxneon.com/books/modern_perl/>

=head2 Other interesting, non-Perl books

You might notice several familiar Perl concepts in this collection of
ACM columns from Jon Bentley. The similarity to the title of the major
Perl book (which came later) is not completely accidental:

=over 4

=item I<Programming Pearls>

 by Jon Bentley
 ISBN 978-0-201-65788-3 [2nd edition, October 1999]

=item I<More Programming Pearls>

 by Jon Bentley
 ISBN 0-201-11889-0 [January 1988]

=back

=head2 A note on freshness

Each version of Perl comes with the documentation that was current at
the time of release. This poses a problem for content such as book
lists. There are probably very nice books published after this list
was included in your Perl release, and you can check the latest
released version at L<https://perldoc.perl.org/perlbook.html> .

Some of the books we've listed appear almost ancient in internet
scale, but we've included those books because they still describe the
current way of doing things. Not everything in Perl changes every day.
Many of the beginner-level books, too, go over basic features and
techniques that are still valid today. In general though, we try to
limit this list to books published in the past five years.

=head2 Get your book listed

If your Perl book isn't listed and you think it should be, let us know.
L<mailto:perl5-porters@perl.org>

=cut
